﻿namespace HeuristicLab.BenchmarkSuite.Problems {
  using System.Linq;

  using HeuristicLab.Common;
  using HeuristicLab.Core;

  public class Data : NamedItem {
    public Data(double bestResult, double worstResult, int testCount, int trainingCount,
      int inputArgumentCount, int outputArgumentCount, Example[] exmaples, IExampleParser exampleParser) {
      WorstResult = worstResult;
      BestResult = bestResult;
      OriginalTrainingCount = trainingCount;
      OriginalTestCount = testCount;
      InputArgumentCount = inputArgumentCount;
      OutputArgumentCount = outputArgumentCount;
      Examples = exmaples;
      ExampleParser = exampleParser;

      Description = "Examples";
    }

    public Data(Data origin, Cloner cloner) : base(origin, cloner) {
      this.BestResult = origin.BestResult;
      this.WorstResult = origin.WorstResult;
      this.OriginalTestCount = origin.OriginalTestCount;
      this.OriginalTrainingCount = origin.OriginalTrainingCount;
      this.Examples = origin.Examples.Select(cloner.Clone).ToArray();
    }

    public readonly IExampleParser ExampleParser;
    public readonly Example[] Examples;
    public readonly int OriginalTestCount;
    public readonly int OriginalTrainingCount;
    public readonly double WorstResult;
    public readonly double BestResult;
    public readonly int InputArgumentCount;
    public readonly int OutputArgumentCount;

    public override IDeepCloneable Clone(Cloner cloner) {
      return new Data(this, cloner);
    }
  }
}
