﻿namespace HeuristicLab.BenchmarkSuite.Problems {

  using HeuristicLab.Common;

  public class Example : DeepCloneable {
    public Example() {
      InputInt = new long[0];
      InputFloat = new double[0];
      InputBoolean = new bool[0];
      OutputInt = InputInt;
      OutputFloat = InputFloat;
      OutputBoolean = InputBoolean;
    }

    public Example(Example origin, Cloner cloner) : base(origin, cloner) {
      origin.CopyTo(this);
    }

    public void CopyTo(Example example) {
      example.InputArgs = this.InputArgs;
      example.OutputArgs = this.OutputArgs;

      example.InputBoolean = this.InputBoolean;
      example.InputInt = this.InputInt;
      example.InputFloat = this.InputFloat;

      example.OutputBoolean = this.OutputBoolean;
      example.OutputInt = this.OutputInt;
      example.OutputFloat = this.OutputFloat;
    }

    public string[] InputArgs { get; set; }
    public string[] OutputArgs { get; set; }
    public long[] InputInt { get; set; }
    public double[] InputFloat { get; set; }
    public bool[] InputBoolean { get; set; }
    public long[] OutputInt { get; set; }
    public double[] OutputFloat { get; set; }
    public bool[] OutputBoolean { get; set; }


    public override IDeepCloneable Clone(Cloner cloner) {
      return new Example(this, cloner);
    }
  }
}
