﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Configuration {
  using System.Collections.Generic;

  public interface IReadonlyPushGpConfiguration {
    bool IsBooleanStackEnabled { get; }
    bool IsIntegerStackEnabled { get; }
    bool IsFloatStackEnabled { get; }
    bool IsCodeStackEnabled { get; }
    bool IsNameStackEnabled { get; }
    double ErcProbability { get; }
    int EvalPushLimit { get; }
    int MaxDepth { get; }
    int MaxPointsInProgram { get; }
    int MaxPointsInRandomExpression { get; }
    bool TopLevelPushCode { get; }
    bool TopLevelPopCode { get; }
    int MinRandomInteger { get; }
    int MaxRandomInteger { get; }
    double MinRandomFloat { get; }
    double MaxRandomFloat { get; }
    double NewErcNameProbability { get; }

    IReadOnlyList<string> EnabledExpressions { get; }
  }
}
