﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Data {
  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;

  public class ExpressionTree {
    public ExpressionNode Root { get; set; }

    public static ExpressionTree BuildTree(ExecExpandExpression program) {
      var tree = new ExpressionTree { Root = new ExpressionNode(program) };

      for (var i = program.State.Expressions.Count - 1; i >= 0; i--) {
        tree.Root.Children.Add(ExpressionNode.CreateNode(program.State.Expressions[i]));
      }

      return tree;
    }
  }
}