﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
  using System;
  using System.Collections.Generic;

  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;

  using Interpreter;

  public abstract class Expression {
    public bool CanExpand { get { return this.GetType() == typeof(ExecExpandExpression); } }

    public static readonly IReadOnlyCollection<Expression> EmptyContainer = new Expression[0];

    public virtual string StringRepresentation
    {
      get
      {
        var attribute = (PushExpressionAttribute)Attribute.GetCustomAttribute(this.GetType(), typeof(PushExpressionAttribute));

        return attribute != null
          ? attribute.ExpressionName
          : string.Empty;
      }
    }

    public abstract void Eval(IPushGpInterpreter interpreter);

    public override string ToString() {
      return this.StringRepresentation;
    }
  }
}