﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem {
  using HeuristicLab.BenchmarkSuite.Problems;
  using HeuristicLab.Common;
  using HeuristicLab.Core;
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;

  [StorableClass]
  public class PushSolution : NamedItem {
    public readonly double Quality;
    public readonly PushProgram Program;
    public readonly Data Data;
    public readonly IRandom Random;
    public readonly PushGpInterpreterPool Pool;

    public PushSolution(PushProgram program, double quality, Data data,
      IRandom random, PushGpInterpreterPool pool)
      : base("Solution", "A push solution.") {
      Program = program;
      Quality = quality;
      Data = data;
      Random = random;
      Pool = pool;
    }

    public PushSolution(PushSolution origin, Cloner cloner) : base(origin, cloner) {
      Program = origin.Program;
      Quality = origin.Quality;
    }

    [StorableConstructor]
    private PushSolution(bool deserializing) : base(deserializing) { }

    [StorableHook(HookType.AfterDeserialization)]
    private void AfterDeserialization() {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new PushSolution(this, cloner);
    }
  }
}
